program explicit_matmul


!Legge in input due matrici A(n,m) e B(m,p)
!e calcola la matrice C(n,p) come prodotto
!righe per colonne: C=A*B


 implicit none

 integer, parameter    :: n=3,m=2,p=3
 real*8     :: a(n,m),b(m,p),c(n,p)
 integer    :: i,j,k
 real*8     :: tmp

 write(*,*) 'Matrix A (columns)'
 read(*,*) a
 write(*,*) 'Matrix B (columns)'
 read(*,*) b

 do i=1,n
    do j=1,p
       tmp=0.d0
       do k=1,m
          tmp=tmp+a(i,k)*b(k,j)
       enddo   
       c(i,j)=tmp 
    enddo
 enddo

 write(*,*) 'Matrix product'
 do i=1,n
    write(*,*) (c(i,j), j=1,p)
 enddo   

 stop

end program explicit_matmul      
