program norma_vettore

!Euclidean norm of a vector

 implicit none     

 integer              :: n,i
 real*8               :: s
 real*8, allocatable  :: x(:)

 do
   write(*,*) 'n=?'
   read(*,*) n
   if (n.gt.0) exit
 enddo
 allocate(x(n))
 read(*,*) x

 s=0.d0
 do i=1,n
    s=s+x(i)**2
 enddo
 s=dsqrt(s)

 deallocate(x)

 write(*,*) 'Norm', s

 stop

end program norma_vettore      
