program prodotto_scalare

!Scalar product between two vectors 

 implicit none

 real*8,allocatable      :: a(:),b(:)
 real*8                  :: p
 integer                 :: n,i

 
 do
    write(*,*) 'n=?'
    read(*,*) n
    if (n.gt.0) exit
 enddo

 allocate(a(n),b(n))

 write(*,*) 'First vector'
 read(*,*) a
 write(*,*) 'Second vector'
 read(*,*) b 

 p=0.d0

 do i=1,n      
    p=p+a(i)*b(i)
 enddo

 deallocate(a,b)

 write(*,*) 'Prodotto scalare', p

 stop

end program prodotto_scalare      
